# http://www.igvita.com/2008/08/10/asynchronous-db-dbslayer-httpasynchronous-db-dbslayer-http

require 'rubygems'
require 'net/http'
require 'json'
require 'cgi'

# instead of querying the database, send a HTTP call to DBSlayer
def http_request(query)
  Net::HTTP.start('localhost', 81) { |http|
      req = Net::HTTP::Get.new('/db?'+ CGI.escape(query.to_json))
      response = http.request(req)      
      return JSON.parse(response.body)
    }
end

# select the database. Output:
#  >> {"HOST_INFO" : "Localhost via UNIX socket" , "RESULT" : {"SUCCESS" : true} , "SERVER" : "localhost"}
http_request({'SQL' => 'use dbslayer'})

# issue the real sql query! Output:
# >> ["bobblehead", 5]
# >> ["toy", 2]
# >> ["gadget", 3]
http_request({'SQL' => 'select * from widgets'})['RESULT']['ROWS'].each do |row| 
  p row
end